package tda552.plotter;

import java.awt.*;
import javax.swing.*;

public class Plotter extends JPanel {
  private Function fun;
  private PlotStrategy strategy;
  private Contrast contrast;

  public Plotter(Function fun, PlotStrategy strategy) {
    this.fun = fun;
    this.strategy = strategy;
    this.contrast = new HighContrast();
  }

  public void setContrast(Contrast contrast) {
    this.contrast = contrast;
  }

  public void paintComponent(Graphics g) {
    super.paintComponent(g);
    contrast.setBackgroundColor(this);
    plotFunction(g);
  }

  private void plotFunction(Graphics g) {
    contrast.setForegroundColor(this);
    strategy.plot(g, fun, getWidth(), getHeight());
  }
}